package org.cumulus4j.integrationtest.gwt.client;

import com.google.gwt.user.client.rpc.impl.RemoteServiceProxy;
import com.google.gwt.user.client.rpc.impl.ClientSerializationStreamWriter;
import com.google.gwt.user.client.rpc.SerializationStreamWriter;
import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.impl.RequestCallbackAdapter.ResponseReader;
import com.google.gwt.user.client.rpc.SerializationException;
import com.google.gwt.user.client.rpc.RpcToken;
import com.google.gwt.user.client.rpc.RpcTokenException;
import com.google.gwt.core.client.impl.Impl;
import com.google.gwt.user.client.rpc.impl.RpcStatsContext;

public class MovieService_Proxy extends RemoteServiceProxy implements org.cumulus4j.integrationtest.gwt.client.MovieServiceAsync {
  private static final String REMOTE_SERVICE_INTERFACE_NAME = "org.cumulus4j.integrationtest.gwt.client.MovieService";
  private static final String SERIALIZATION_POLICY ="143D08BDB365AAC51F6B895E7F03B814";
  private static final org.cumulus4j.integrationtest.gwt.client.MovieService_TypeSerializer SERIALIZER = new org.cumulus4j.integrationtest.gwt.client.MovieService_TypeSerializer();
  
  public MovieService_Proxy() {
    super(GWT.getModuleBaseURL(),
      "movieService", 
      SERIALIZATION_POLICY, 
      SERIALIZER);
  }
  
  public void fetchSomeMovies(java.lang.String cryptoSessionID, com.google.gwt.user.client.rpc.AsyncCallback callback) {
    RpcStatsContext statsContext = new RpcStatsContext();
    boolean toss = statsContext.isStatsAvailable() && statsContext.stats(statsContext.timeStat("MovieService_Proxy.fetchSomeMovies", "begin"));
    SerializationStreamWriter streamWriter = createStreamWriter();
    // createStreamWriter() prepared the stream
    try {
      if (getRpcToken() != null) {
        streamWriter.writeObject(getRpcToken());
      }
      streamWriter.writeString(REMOTE_SERVICE_INTERFACE_NAME);
      streamWriter.writeString("fetchSomeMovies");
      streamWriter.writeInt(1);
      streamWriter.writeString("java.lang.String/2004016611");
      streamWriter.writeString(cryptoSessionID);
      String payload = streamWriter.toString();
      toss = statsContext.isStatsAvailable() && statsContext.stats(statsContext.timeStat("MovieService_Proxy.fetchSomeMovies",  "requestSerialized"));
      doInvoke(ResponseReader.STRING, "MovieService_Proxy.fetchSomeMovies", statsContext, payload, callback);
    } catch (SerializationException ex) {
      callback.onFailure(ex);
    }
  }
  @Override
  public SerializationStreamWriter createStreamWriter() {
    ClientSerializationStreamWriter toReturn =
      (ClientSerializationStreamWriter) super.createStreamWriter();
    if (getRpcToken() != null) {
      toReturn.addFlags(ClientSerializationStreamWriter.FLAG_RPC_TOKEN_INCLUDED);
    }
    return toReturn;
  }
  @Override
  protected void checkRpcTokenType(RpcToken token) {
    if (!(token instanceof com.google.gwt.user.client.rpc.XsrfToken)) {
      throw new RpcTokenException("Invalid RpcToken type: expected 'com.google.gwt.user.client.rpc.XsrfToken' but got '" + token.getClass() + "'");
    }
  }
}
